#ifndef __events_hh
#define __events_hh

#include <cstdlib>

typedef enum
{
	E_NONE = 0,
	E_GLOBAL
} eventtype;

class event
{
	eventtype type;
public:
	event(eventtype t) : type(t)
	{
	}
	virtual ~event()
	{
	}
	virtual string getdata(const string &) const = 0;
	inline eventtype what() const { return type; }
};

class globalevent : public event
{
	string s;
public:
	globalevent(const string &msg) : event(E_GLOBAL), s(msg)
	{
	}
    virtual string getdata(const string &) const
    {
    	return s;
    }
};

#endif
